###########################################################################
#
#   Copyright (c) 2000,2001 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000,2001 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: renfro $
# $Revision: 1.3 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import MessageDialog
from Globals import default__class_init__
import Products
import Acquisition
import AccessControl.Role
import OFS.SimpleItem
from Products.WarpFramework import base_item
import string
import address_book_contact_email

address_book_contact_add_company_information = HTMLFile('dtml/address_book_contact_add_company_information',
							globals())
manage_add_address_book_contact_form = HTMLFile('dtml/address_book_contact_add', globals())


def manage_add_address_book_contact(self, firstname='', middlename='', nickname='',
				surname='', street='', city='', state='',
				zip='', country='', email='', website='',
				telephone_home='', telephone_mobile='',
				telephone_pager='', telephone_fax='', note='',
				assistant_name='',assistant_phone='',
				assistant_email='', company_name='',
				company_street='', company_city='',
				company_state='', company_zip='',
				company_country='',
				company_employee_job_title='',
				company_employee_department='',
				company_employee_pager='',
				company_employee_email='',
				company_employee_phone='',
				company_employee_fax='',
				company_website='', groups=[],
				REQUEST=None, RESPONSE=None):
    """Add an instance of the address_book_contact class."""

    id = str(self.get_unique_id())

    self._setObject(id,	address_book_contact(id, firstname, middlename,
			surname, nickname, street, city, state,
			zip, country, website, telephone_home,
			telephone_mobile, telephone_pager, telephone_fax,
			note, assistant_name, assistant_phone,
			company_name, company_street, company_city,
			company_state, company_zip, company_country,
			company_employee_job_title,
			company_employee_department,
			company_employee_pager,	company_employee_email,
                        company_employee_phone,
			company_employee_fax, company_website, groups))

    if string.strip(email):

	new_email_id = self[id].manage_add_address_book_contact_email(email, 'Primary email')

    elif string.strip(company_employee_email):

	new_email_id = self[id].manage_add_address_book_contact_email(company_employee_email, 'Primary email')

    else:

	new_email_id = ''

    self[id].primary_email = new_email_id

    if string.strip(assistant_email):

	self[id].manage_add_address_book_contact_email(assistant_email,
			'Assistant email')

    if RESPONSE is not None:

	RESPONSE.redirect(self.absolute_url())

    else:

	return self[id]


class dummy_address_book_contact_email:

	def __init__(self):
	
		self.email = 'No emails'
		self.id = '0'


class address_book_contact(
	Products.ZCatalog.CatalogAwareness.CatalogAware,
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'AddressBookContact'
	icon = 'misc_/AddressBook/dtmldoc.gif'
	help_name = 'address_book_contact.stx'

	deleteable_object = 1

	_properties = (
		{'id':'firstname', 'type':'string'},
		{'id':'middlename', 'type':'string'},
		{'id':'surname', 'type':'string'},
		{'id':'nickname', 'type':'string'},
		{'id':'street', 'type':'text'},
		{'id':'city', 'type':'string'},
		{'id':'state', 'type':'string'},
		{'id':'zip', 'type':'string'},
		{'id':'country', 'type':'string'},
		{'id':'website', 'type':'string'},
		{'id':'telephone_home', 'type':'string'},
		{'id':'telephone_mobile', 'type':'string'},
		{'id':'telephone_pager', 'type':'string'},
		{'id':'telephone_fax', 'type':'string'},
		{'id':'note', 'type':'text'},
		{'id':'assistant_name', 'type':'string'},
		{'id':'assistant_phone', 'type':'string'},
		{'id':'company_name', 'type':'string'},
		{'id':'company_street', 'type':'text'},
		{'id':'company_city', 'type':'string'},
		{'id':'company_state', 'type':'string'},
		{'id':'company_zip', 'type':'string'},
		{'id':'company_country', 'type':'string'},
		{'id':'company_employee_job_title', 'type':'string'},
		{'id':'company_employee_department', 'type':'string'},
		{'id':'company_employee_pager', 'type':'string'},
		{'id':'company_employee_email', 'type':'string'},
		{'id':'company_employee_phone', 'type':'string'},
		{'id':'company_employee_fax', 'type':'string'},
		{'id':'company_website', 'type':'string'},
		{'id':'groups', 'type':'tokens'}
	)

	manage_add_address_book_contact_email_form = \
		address_book_contact_email.manage_add_address_book_contact_email_form
	manage_add_address_book_contact_email = \
		address_book_contact_email.manage_add_address_book_contact_email

	meta_types = (
		{
			'name':'AddressBookContactEmail',
			'action':'manage_add_address_book_contact_email_form'
		},
	)

	__ac_permissions__ = (
		('View management screens',
			('manage_tabs', 'manage_main')
		),
		('Change Permissions',
			('manage_access',)
		),
		('View AddressBookContacts',
			('', 'base_edit'),
			['Manager', 'Owner', 'AddressBook Manager', 'AddressBook Editor', 'AddressBook User'],
		),
		('Edit AddressBookContacts',
			(
				'base_edit_properties', 'update_groups', 'manage_set_primary_email',
				'manage_add_address_book_contact_email_form',
				'manage_add_address_book_contact_email',
			),
			['Manager', 'Owner', 'AddressBook Manager', 'AddressBook Editor'],
		),
		('Manage AddressBookContacts',
			(
				'copy',
			),
			['Manager', 'Owner', 'AddressBook Manager'],
		),
	)

	base_edit = index_html = HTMLFile('dtml/address_book_contact_index', globals())


	def use_local_navigation(self):
		"""Returns a boolean value depending on the settings of the address book."""

		return self.get_product_base_instance().use_local_navigation


	def use_breadcrumbs(self):
		"""Returns a boolean value depending on the settings of the address book."""

		return self.get_product_base_instance().use_breadcrumbs


	def render_group_widget(self):
		"""Returns an HTML widget for editing groups this contact is a part of."""

		select_widget = """<select name="groups" size="10" multiple>""" + \
					"""<option value="">- - - - - - - - </option>"""

		for group in self.get_all_groups():

			if group.id in self.groups:

				selected = " selected"

			else:

				selected = ""

			select_widget = select_widget + """<option value="%s"%s>%s</option>""" % \
								(group.id, selected, group.name)

		return select_widget + "</select>"


	def update_groups(self, REQUEST, RESPONSE):
		"""Updates group information."""

		try:

			groups = REQUEST['groups']

		except KeyError:

			# No groups were selected

			groups = []

		if not type(groups) == type([]):

			groups = [groups]

		self.groups = groups

		RESPONSE.redirect(self.absolute_url() + '/')


	def get_email(self):
		"""Returns the primary email address object."""


		try:
	
			return self[self.primary_email]

		except KeyError:

			try:

				return self.objectValues('AddressBookContactEmail')[0]

			except IndexError:

				return dummy_address_book_contact_email()


	def get_emails(self):
		"""Returns a list of all the email addresses contained."""

		return self.objectValues('AddressBookContactEmail')


	def get_secondary_emails(self):
		"""Returns a list of secondary emails."""

		emails = self.get_emails()
		secondary_emails = []

		for email in emails:

			if not email.id == self.primary_email:

				secondary_emails.append(email)

		return secondary_emails


	def render_html_emails(self):
		"""Returns a string with email addresses."""

		emails = []

		if self.product_installed('GUM') and self.get_gum():

			gum = self.get_gum()

		else:

			gum = None

		for email in self.get_secondary_emails():

			if gum:

				emails.append("""<a href="%s/compose_mail?recipients=%s">%s</a>""" % \
					(gum.absolute_url(), email.email, email.email))

			else:

				emails.append("""<a href="mailto:%s">%s</a>""" % \
					(email.email, email.email))

		return string.join(emails, ', ')


	def manage_set_primary_email(self, ids=[], RESPONSE=None):
		"""Sets the primary email."""

		try:

			self.set_primary_email(ids[0])

		except IndexError:

			pass

		if RESPONSE is not None:

			RESPONSE.redirect(self.relative_url())


	def set_primary_email(self, id):
		"""Sets the primary email."""

		self.primary_email = id


	def _render_email_widget(self):
		"""Returns a widget for email selection."""

		if not self.get_emails():

			return ''

		select_widget = """<select name="email.%s">""" % self.id

		for email in self.get_emails():

			select_widget = select_widget + """<option value="%s">%s</option>""" % \
					(email.email, email.email)

		return select_widget + "</select>"
		

	def __init__(self, id, firstname='', middlename='', surname='', nickname='', street='',
			city='', state='', zip='', country='', website='',
			telephone_home='', telephone_mobile='', telephone_pager='', telephone_fax='',
			note='', assistant_name='', assistant_phone='',
			company_name='', company_street='', company_city='',
			company_state='', company_zip='', company_country='',
			company_employee_job_title='', company_employee_department='',
			company_employee_pager='', company_employee_email='',
                        company_employee_phone='',
			company_employee_fax='', company_website='', groups=[]):
		"""Initialize the class instance."""

		self.id = id
		self.firstname = firstname
		self.middlename = middlename
		self.surname = surname
		self.nickname = nickname
		self.street = street
		self.city = city
		self.state = state
		self.zip = zip
		self.country = country
		self.website = website
		self.telephone_home = telephone_home
		self.telephone_mobile = telephone_mobile
		self.telephone_pager = telephone_pager
		self.telephone_fax = telephone_fax
		self.note = note
		self.assistant_name = assistant_name
		self.assistant_phone = assistant_phone
		self.company_name = company_name
		self.company_street = company_street
		self.company_city = company_city
		self.company_state = company_state
		self.company_zip = company_zip
		self.company_country = company_country
		self.company_employee_job_title = company_employee_job_title
		self.company_employee_department = company_employee_department
		self.company_employee_pager = company_employee_pager
		self.company_employee_email = company_employee_email
		self.company_employee_phone = company_employee_phone
		self.company_employee_fax = company_employee_fax
		self.company_website = company_website
		self.groups = groups

		self.primary_email = ''


	def render_website(self):
		"""Renders a browsable string if the website is set."""

		if not string.strip(self.website):

			return ''

		if string.find(self.website, 'http://') > -1 or \
			string.find(self.website, 'https://') > -1:

			website_url = self.website

		else:

			website_url = 'http://' + self.website

		return """<a href="%s">%s</a>""" % (website_url, self.website)


	def manage_copy(self, RESPONSE):
		"""Copies self to a new instance and redirects to it."""

		new_object = self.getParentNode().manage_clone(self, str(self.get_unique_id()))

		new_object.firstname = self.firstname + ' (copy)'

		RESPONSE.redirect(new_object.absolute_url() + '/base_edit')


default__class_init__(address_book_contact)
