###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.4 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.Folder
import todo
import base_item

manage_add_category_form = HTMLFile('dtml/category_add', globals())


def manage_add_category(self, id='', title='', description='', REQUEST=None):
	"Add an instance of the category class"

	new_id = id or self.get_unique_id()

	self._setObject(new_id, category(new_id, title, description))

	if REQUEST is not None:

		REQUEST.RESPONSE.redirect(self.absolute_url())


class category(
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'Category'
	icon = 'misc_/TodoFolder/Folder_icon.gif'

	_properties = (
		{'id':'title', 'type':'string'},
		{'id':'description', 'type':'text'},
		)

	meta_types = (
		{'name':'Todo', 'action':'manage_add_todo_form'},
		)

	manage_add_todo_form = todo.manage_add_todo_form
	manage_add_todo = todo.manage_add_todo

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('Add Todo',
		 ('manage_addTodo', 'manage_addTodoForm')),
		('View Categorys',
		 ('',)),
		)

	index_html = HTMLFile('dtml/category_index', globals())
	base_edit = HTMLFile('dtml/category_edit', globals())


	def __init__(self, id, title='', description=''):
		"Initialize the class instance"

		self.id = id
		self.title = title
		self.description = description


	def get_todos(self):
		"""Returns a time-sorted list of todo-items."""

		todo_items = self.objectValues('Todo')

		todo_items.sort(
			lambda x,y: cmp(x.priority, y.priority)
			)

		return todo_items


	def get_number_of_todos(self):
		"""Returns the number of todos contained."""

		return len(self.get_todos())


default__class_init__(category)

