###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.2 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.Folder
import base_item
import todo_category

manage_add_todo_category_folder_form = HTMLFile('dtml/todo_category_folder_add', globals())


def manage_add_todo_category_folder(self, id='', title='', REQUEST=None):
	"Add an instance of the todo_category_folder class"

	new_id = id or self.get_unique_id()

	self._setObject(new_id, todo_category_folder(new_id, title))

	self[new_id].manage_add_todo_category(id='-1', title='Uncategorized')

	if REQUEST is not None:

		REQUEST.RESPONSE.redirect(self.absolute_url())

	else:

		return new_id


class todo_category_folder(
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'TodoCategoryFolder'
	icon = 'misc_/CalendarFolder/Folder_icon.gif'

	meta_types = (
			{'name':'TodoCategory', 'action':'manage_add_todo_category_form'},
			)

	manage_add_todo_category_form = todo_category.manage_add_todo_category_form
	manage_add_todo_category = todo_category.manage_add_todo_category

	_properties = (
		{'id':'title', 'type':'string'},
		)

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('View Todo_Category_Folder',
		 ('',)),
		)

	index_html = HTMLFile('dtml/todo_category_folder_index', globals())


	def get_default_todo_category(self):
		"""Returns the default todo category."""

		return self.get_todo_categories()[0]


	def get_todo_categories(self):
		"""Returns a list of the todo_category_folders contained."""

		return self.objectValues('TodoCategory')


	def __init__(self, id, title=''):
		"""Initialize the class instance."""

		self.id = id
		self.title = title


default__class_init__(todo_category_folder)

