def install_workspace(container, username='', email='',
			install_gum=1, install_calendar=1,
			install_address_book=1, install_todo_folder=0,
			install_note_folder=1, install_bookmarks=1,
			install_personal_folder=1,
			install_news_host=0,
			use_frames=1,
			use_notifications=1):

	from Products import GUM, CalendarFolder, TodoFolder, Notes, \
				BookmarkFolder, AddressBook, PersonalFolder, NewsHost

	container.use_frames = use_frames
	container.use_notifications = use_notifications
	container.notifications = []

	container.use_local_navigation = 0
	container.use_breadcrumbs = 0
	container.stop_breadcrumbs = 1

	if install_gum:

		gum = GUM.gum.manage_add_gum(container, 'Mail',
				 username, email, 'Your Messenger')

		gum.use_local_navigation = 0
		gum.use_local_preferences = 0
		gum.use_breadcrumbs = 0
		gum.stop_breadcrumbs = 0

	if install_calendar:

		calendar = CalendarFolder.calendar_folder.manage_add_calendar_folder(
				container, 'Calendar', 'Your calendar')

		calendar.use_local_navigation = 0
		calendar.use_local_preferences = 0
		calendar.use_breadcrumbs = 1
		#calendar.stop_breadcrumbs = 1


	if install_address_book:

		address_book = AddressBook.address_book.manage_add_address_book(
				container, 'AddressBook', 'Your address book')

		address_book.use_local_preferences = 0
		address_book.use_local_navigation = 1
		address_book.use_breadcrumbs = 0

	if install_todo_folder:

		todo_folder = TodoFolder.todo_folder.manage_add_todo_folder(
					container, 'Tasks', 'Your tasks', number_of_todos_in_display=5)

		todo_folder.use_local_navigation = 1
		todo_folder.use_local_preferences = 0
		todo_folder.use_breadcrumbs = 1
		todo_folder.stop_breadcrumbs = 1

	if install_bookmarks:

		bookmark_folder = BookmarkFolder.bookmark_folder.manage_add_bookmark_folder(
					container, 'Bookmarks', 'Your bookmarks', '')

		bookmark_folder.use_local_navigation = 1
		bookmark_folder.use_local_preferences = 0
		bookmark_folder.use_breadcrumbs = 1

	if install_note_folder:

		notes = Notes.notes.manage_add_notes(
				container, 'Notes', 'Your notes', '')

		notes.use_local_preferences = 0
		notes.use_local_navigation = 1
		notes.use_breadcrumbs = 0

	if install_personal_folder:

		personal_folder = PersonalFolder.personal_folder.manage_add_personal_folder(
					container, 'PersonalFolder','Your files', '')

		personal_folder.use_local_navigation = 1
		personal_folder.use_local_preferences = 0
		personal_folder.use_breadcrumbs = 1

	if install_news_host:

		news_host = NewsHost.news_host.manage_add_news_host(container,
				id='NewsHost', server='localhost', port=119)

		news_host.use_local_navigation = 1
		news_host.use_local_preferences = 0
		news_host.use_breadcrumbs = 1
